#define PARSE_ERROR "0: ParseError"
#define MESH_ID_ERROR1 "1: Mesh tag defined at World Level without ID"
#define MAT_ID_ERROR1 "2: Material tag defined at World Level without ID"
#define MAT_ID_ERROR2 "3: Material tag defined at Object Level without ID"
#define MAT_ID_ERROR3 "4: : Material tag defined at Mesh Level without ID"
#define LIGHTS_ERROR1 "5: More than 8 directional Lights"
#define POS_ID_ERROR1 "6: Position tag defined at Mesh Level without ID"
#define NORMAL_ID_ERROR1 "7: Normal tag defined at Mesh Level without ID"
#define PATH_ID_ERROR1 "8: Attribute for Object Tag not called PathID or ID"
#define DATA_ERROR1 "9: Attribute for Data Tag not called Org"
#define DATA_ERROR2 "10: The Org attribute for the Data Tag was not found"
#define STRING_ERROR1 "11: Attribute for String Tag not called Name"
#define STRING_ERROR2 "12: The Name attribute for the String Tag was not found"
#define BIN_ERROR1 "13: Attribute for Bin Tag not called Name"
#define BIN_ERROR2 "14: The Name attribute for the Bin Tag was not found"
#define TEXTURE_ID_ERROR1 "15: Texture tag defined at Mesh Level without ID"
#define TEXTURE_ID_ERROR2 "16: Texture tag defined at Object Level without ID"
#define TEXTURE_ID_ERROR3 "17: Texture tag defined at World Level without ID"
#define TEXTUREBUFFER_ERROR1 "18: Attribute for TextureRGB or TextureRGBA Tag not called Width, Height or ID"
#define TEXTUREBUFFER_ERROR2 "19: TextureRGB or TextureRGBA Tag found without a width"
#define TEXTUREBUFFER_ERROR3 "20: TextureRGB or TextureRGBA Tag found without a height"
#define TEXTUREBUFFER_ERROR4 "21: TextureRGB or TextureRGBA Tag defined at World level without ID"
#define TEXTUREBUFFER_ERROR5 "22: TextureRGB has an incorrect amount of data given its width and height"
#define TEXTUREBUFFER_ERROR6 "23: TextureRGB or TextureRGBA Tag defined at Object level without ID"
#define TEXTUREBUFFER_ERROR7 "24: TextureRGB or TextureRGBA Tag defined at Mesh level without ID"
#define TEXTUREBUFFER_ERROR8 "25: TextureRGBA has an incorrect amount of data given its width and height"
#define TEXTURECOORDINATE_ID_ERROR1 "26: Texture Coordinate tag defined at Mesh Level without ID"
#define TEXTURECOORDINATE_ID_ERROR2 "27: Texture Coordinate tag defined at Object Level without ID"
#define TEXTURECOORDINATE_ID_ERROR3 "28: Texture Coordinate tag defined at World Level without ID"
#define WORLD_LIGHTING_ERROR "29: Lighting required for World"
#define WORLD_BACKGROUND_ERROR "30: Background element required for World"
#define WORLD_OBJECTS_ERROR "31: At least one object required in world"
#define UNRESOLVED_OBJECT_ERROR "32: An object could not be resolved"
#define OBJECT_MESH_SUB_OBJ_ERROR "33: An object cannot contain a mesh and sub objects"
#define PATH_ID_RANGE_ERROR "34: PathID out of range"
#define TRANSFORM_ERROR1 "35: Forward vector cannot have length zero"
#define TRANSFORM_ERROR2 "36: Up vector cannot have length zero"
#define TRANSFORM_ERROR3 "37: Up vector and forward vector cannot be colinear"
#define TRANSFORM_ERROR4 "38: Scale must be positive"
#define FACE_ERROR1 "39: Face must contain FaceVertex1, FaceVertex2 & FaceVertex3"
#define FACE_ERROR2 "40: Face must contain a material or a materialRef"
#define MAT_EMISSIVE_RANGE_ERROR "41: Emissive material values must be between 0 and 1 inclusive"
#define MAT_DIFFUSE_RANGE_ERROR "42: Diffuse material values must be between 0 and 1 inclusive"
#define MAT_SPECULAR_RANGE_ERROR "43: Specular material values must be between 0 and 1 inclusive"
#define MAT_AMBIENT_RANGE_ERROR "44: Ambient material values must be between 0 and 1 inclusive"
#define MAT_SHININESS_RANGE_ERROR "45: Shininess material values must be between 0 and 128 inclusive"
#define MAT_ALPHA_RANGE_ERROR "46: Alpha material values must be between 0 and 1 inclusive"
#define BACKGROUND_COLOR_RANGE "47: Background color values must be between 0 and 1 inclusive"
#define LIGHT_DIFFUSE_RANGE_ERROR "48: Diffuse light values must be between 0 and 1 inclusive"
#define LIGHT_SPECULAR_RANGE_ERROR "49: Specular light values must be between 0 and 1 inclusive"
#define LIGHT_AMBIENT_RANGE_ERROR "50: Ambient light values must be between 0 and 1 inclusive"
#define FACE_VERTEX1_ERROR "51: A face can contain only 1 FaceVertex1(FV1) element"
#define FACE_VERTEX2_ERROR "52: A face can contain only 1 FaceVertex2(FV2) element"
#define FACE_VERTEX3_ERROR "53: A face can contain only 1 FaceVertex3(FV3) element"
#define FACE_MATERIAL_ERROR "54: A face can have only 1 Material element"
#define MATERIAL_REQUIRES_ERROR "55: A material needs Diffuse and Ambient elements"
#define WORLD_LIGHTING_ERROR2 "56: Only one lighting element for the world"
#define WORLD_BACKGROUND_ERROR2 "57: Only one background element for the world"
#define STRING_LENGTH_ERROR "58: String is too long"
#define TAG_NAME_TOO_LONG "59: Tag name too long"
#define PATCH_ID_RANGE_ERROR "60: PatchIDs must be greater than 0"
#define IMPROPER_TAG_ERROR "61: Tag Inappropriate in current context"
#define TRANSFORM_FORWARD_REQUIRES "62: Transform requires exactly 1 forward vector"
#define TRANSFORM_UP_REQUIRES "63: Transform requires exactly 1 up vector"
#define TRANSFORM_POSITION_REQUIRES "64: Transform requires exactly 1 position vector"
#define FACE_FV1_REQUIRES "65: Face requires exactly 1 FV1 element"
#define FACE_FV2_REQUIRES "66: Face requires exactly 1 FV2 element"
#define FACE_FV3_REQUIRES "67: Face requires exactly 1 FV3 element"
#define FACE_MATERIAL_REQUIRES "68: Face requires exactly 1 material"
#define TEXTURE_IMAGE_REQUIRES "69: Texture requires exactly 1 texture image"
#define TEXTURE_FUNCTION_REQUIRES "70: Texture requires exactly 1 texture function"
#define TEXTURE_WRAP_REQUIRES "71: Texture requires exactly 1 texture wrap function"
#define MATERIAL_AMBIENT_REQUIRES "72: Material requires exactly 1 ambient element"
#define MATERIAL_DIFFUSE_REQUIRES "73: Material requires exactly 1 diffuse element"
#define BACKGROUND_REQUIRES "74: Background requires exactly 1 backcolor element"
#define LIGHTING_REQUIRES "75: Lighting requires exactly 1 ambient element or 1+ Directional Light elements"
#define DIRECTIONAL_LIGHT_DIRECTION_REQUIRES "76: Directional Lights require exactly 1 direction element"
#define DIRECTIONAL_LIGHT_DIFFUSE_REQUIRES "77: Directional Lights require at most 1 diffuse element"
#define DIRECTIONAL_LIGHT_SPECULAR_REQUIRES "78: Directional Lights require at most 1 specular element"
#define DATA_REQUIRES "79: Data Element requires at least 1 bin or string element"
#define FLOAT_NUMBER_ERROR "80: Number is not a valid float (inf) or (nan)"
#define DOUBLE_NUMBER_ERROR "81: Number is not a valid double (inf) or (nan)"
#define INT_NUMBER_ERROR "82: Number is not a valid int (inf) or (nan)"
#define THREE_VECTOR_ERROR "83: Unable to parse 3 numbers from a 3D vector"
#define TWO_VECTOR_ERROR "84: Unable to parse 2 numbers from a 2D vector"
#define READ_NUMBER_ERROR "85: Unable to parse number"
#define FOUR_VECTOR_ERROR "86: Unable to parse 4 numbers from a 4 vector"
#define OBJECT_NEEDS_DATA "87: Tag in object needs data"
#define MESH_NEEDS_DATA "88: Tag in mesh needs data"
#define FACE_NEEDS_DATA "89: Tag in face needs data"
#define MATERIAL_NEEDS_DATA "90: Tag in material needs data"
#define TRANSFORM_NEEDS_DATA "91: Tag in transform needs data"
#define BACKGROUND_NEEDS_DATA "92: Tag in background needs data"
#define LIGHTING_NEEDS_DATA "93: Tag in lighting needs data"
#define DATA_NEEDS_DATA "94: Tag in Data needs data"
#define TEXTURE_NEEDS_DATA "95: Tag in Texture needs data"
#define WORLD_NEEDS_DATA "96: Tag in world needs data"
#define UNABLE_TO_OPEN_FILE "97:Unable to open file"
#define PATCH_IN_PATCH "98: No patches can be defined in patches"
#define OBJECT_NUM_TRANSFORMS_ERROR "99: At most one transform per object"
#define OBJECT_NUM_MESHES_ERROR "100: At most one mesh per object"
#define TRANSFORM_NUM_SCALES_ERROR "101: At most one scale per transform"
#define FACE_NUM_TEXTURES_ERROR "102: At most one texture in a face"
#define FACE_VERTEX_NEEDS_DATA "103: Tag in Face Vertex needs data"
#define FACE_VERTEX_ONE_POS "104: FaceVertex requires exactly 1 position"
#define FACE_VERTEX_NORM "105: FaceVertex can have at most 1 normal"
#define FACE_VERTEX_TC "106: FaceVertex can have at most 1 texture coordinate"
#define TEXTURE_BORDER_COLOR "107: Texture can have at most 1 texture border color"
#define MATERIAL_EMISSIVE_REQUIRES "108: Material can have at most 1 emissive component"
#define MATERIAL_ALPHA_REQUIRES "109: Material can have at most 1 alpha component"
#define MATERIAL_SHININESS_REQUIRES "110: Material can have at most 1 shininess component"
#define MATERIAL_SPECULAR_REQUIRES "111: Material can have at most 1 specular component"
#define DIRECTIONAL_LIGHT_DIFSPEC_REQUIRES "112: Directional Lights require a diffuse or specular element"
#define TEXTUREBUFFER_ERROR9 "113: TextureRGB or TextureRGBA Tag found defined within a Texture Tag"
#define ZERO_DIRECTIONVECTOR_ERROR "114: A vector to be used as a direction was zero"
#define EXTERNAL_OBJECT_NEEDS_DATA "115: Tag in Included Object needs data"
#define EXTERNAL_OBJECT_EXTENTS_REQUIRES "116: Included object needs exactly 1 extents"
#define EXTERNAL_OBJECT_REF_REQUIRES "117: Included object needs exactly 1 ref"
#define SIX_VECTOR_ERROR "118: Unable to parse 6 numbers from a 6 vector"
#define EXTERNAL_OBJECT_REFTYPE_REQUIRES "119: Included object needs exactly 1 reftype"
#define EXTERNAL_OBJECT_TRANSFORM_REQUIRES "120: Included object needs at most 1 transform"
#define EXTENTS_RELATION_ERROR "121: Max extents values must be greater than Min extents values"
#define BINARY_DATA_INVALID_CHAR_ERROR "122: Invalid hex character in binary data"
#define BINARY_DATA_INVALID_LENGTH "123: Hex characters in binary data must have length divisible by 2"
#define FILE_IN_USE "124: The file you wish to import is in use"
#define WORLD_NUM_MESHES_ERROR "125: At most one mesh per world"
#define WORLD_MESH_SUB_OBJ_ERROR "126: The world can not have both a mesh and subobjects"
#define SMOOTHING_GROUP_OUT_OF_RANGE "127: Smoothing groups can only between 0 and 31 inclusive"
#define LINE_NEEDS_DATA "128: Tag in line needs data"
#define LINE_LV1_REQUIRES "129: Line requires exactly 1 LV1 element"
#define LINE_LV2_REQUIRES "130: Line requires exactly 1 LV2 element"
#define LINE_MATERIAL_REQUIRES "131: Line requires exactly 1 material"
#define LINE_LINESTYLE_REQUIRES "132: Line requires exactly 1 linestyle"
#define LINE_NUM_TEXTURES_ERROR "133: At most one texture in a line"
#define POINT_NEEDS_DATA "134: Tag in point needs data"
#define POINT_PV1_REQUIRES "135: Point requires exactly 1 PV1 element"
#define POINT_MATERIAL_REQUIRES "136: Point requires exactly 1 material"
#define POINT_POINTSTYLE_REQUIRES "137: Point requires exactly 1 pointstyle"
#define POINT_NUM_TEXTURES_ERROR "138: At most one texture in a point"
#define LINESTYLE_NEEDS_DATA "139: Tag in linestyle needs data"
#define LINESTYLE_WIDTH_REQUIRES "140: LineStyle requires exactly 1 linewidth element"
#define LINESTYLE_PATTERN_REQUIRES "141: LineStyle can have at most 1 linepattern element"
#define LINESTYLE_PATTERNFACTOR_REQUIRES "142: LineStyle can have at most 1 linepatternfactor element"
#define LINESTYLE_WIDTH_RANGE_ERROR "143: LineStyle widths must be greater than zero"
#define LINESTYLE_PATTERN_RANGE_ERROR "144: LineStyle pattern must contain exactly 4 hexadecimal digits"
#define LINESTYLE_PATTERNFACTOR_RANGE_ERROR "145:  LineStyle pattern factor must be between 1 and 256 inclusive"
#define POINTSTYLE_NEEDS_DATA "146: Tag in pointstyle needs data"
#define POINTSTYLE_SIZE_REQUIRES "147: PointStyle requires exactly 1 pointsize element"
#define POINTSTYLE_SIZE_RANGE_ERROR "148: PointStyle size must be greater than zero"
#define LINESTYLE_ID_ERROR1 "149: LineStyle tag defined at World Level without ID"
#define LINESTYLE_ID_ERROR2 "150: LineStyle tag defined at Object Level without ID"
#define LINESTYLE_ID_ERROR3 "151: LineStyle tag defined at Mesh Level without ID"
#define POINTSTYLE_ID_ERROR1 "152: PointStyle tag defined at World Level without ID"
#define POINTSTYLE_ID_ERROR2 "153: PointStyle tag defined at Object Level without ID"
#define POINTSTYLE_ID_ERROR3 "154: PointStyle tag defined at Mesh Level without ID"
#define EXTGEOMELEM_NO_TYPE "155: The Type attribute for the ExtGeomElem tag was not found"
#define EXTGEOMELEM_ATTR_NOT_CALLED_TYPE "156: Attribute for the ExtGeomElem tag not called Type"
#define EXTGEOM_NEEDS_DATA "157: Tag in extgeom needs data"
#define EXTGEOMELEM_NO_DATA_OR_EXTENTS "158: No ExtGeomElemData or ExtGeomElemExtents tag/tags"
#define EXTGEOMELEMDATA_MORE_THAN_ONE_DATA_TAG "159: More than one ExtGeomElemData tag"
#define EXTGEOMELEMDATA_INVALID_LENGTH "160: Invalid length of ExtGeomElemData"
#define EXTGEOMELEMDATA_INVALID_BIN_DATA "161: Invalid binary data for ExtGeomElemData tag"
#define EXTGEOMELEMEXTENTS_MORE_THAN_ONE_EXTENTS_TAG "162: More than one ExtGeomElemExtents tag"
#define EXTGEOMELEMEXTENTS_INVALID_VECTOR "163: ExtGeomElemExtents tag contains invalid 6 double vector"
#define EXTGEOMELEMPRIORITY_MORE_THAN_ONE_PRIORITY_TAG "164: More than one ExtGeomElemPriority tag"
#define EXTGEOMELEMPRIORITY_INVALID_PRIORITY_TAG "165: Invalid ExtGeomElemPriority tag"
#define EXTGEOMELEMPRIORITY_VALUE_OUTSIDE_0_1 "166: Value of ExtGeomElemPriority tag must be from 0 to 1"
#define EXTGEOM_NO_EXTGEOMELEM_TAG "167: No ExtGeomElem tags for ExtGeom"
#define EXTGEOM_NO_ORG_ATTRIBUTE "168: The Org attribute for the Extgeom Tag was not found"
#define EXTGEOM_ATTR_NOT_CALLED_ORG "169: Attribute for Extgeom Tag not called Org"
#define TRANSFORM_ERROR5 "170: Forward and up vectors must not be coincident"
#define NAME_ERROR "171: only one object name is allowed"
#define UNIQUE_PATHID_ERROR "172: PathIDs of sibling objects must be unique"