#ifndef __ZLIBDecompress_h
#define __ZLIBDecompress_h

#include <stdio.h>
#include "ZLIB.h"

#ifdef WIN32
#include <windows.h>
#endif

class CZLIBDecompress
{
public:

	bool Initialize(const char *zlibModulePath);
	bool UnInitialize();

	bool SetCompressedData(unsigned int compressedDataLength, const char *compressedData);
	bool ReleaseCompressedData();

	unsigned int GetFillBufferLength();
	bool GetData(char *dataToFill, unsigned int *bytesRead, bool *needsMoreCompressedData, bool *finished);
	
	bool Reset();

	char *GetLastErrorString();

private:

	bool InitCommon();

	bool Error;
	char ErrorBuffer[1024];
	void SetError(char *errorString);
	void SetZLibError(char *errorString, int zlibError);

#ifdef WIN32
	HMODULE DllHandle;
#endif

	z_stream ZStream;
	unsigned int NumCompressedBytes;
	unsigned int NumCompressedBytesLeft;
	char *CompressedBuffer;

	int (__stdcall *inflateInit_) (z_stream *strm, const char *version, int stream_size);
	int (__stdcall *inflate) (z_stream *strm, int flush);
	int (__stdcall *inflateEnd) (z_stream *strm);
	int (__stdcall *inflateReset) (z_stream *strm);
};

/*
class CZLIBFileDecompress
{
public:

	bool Initialize(const char *zlibModulePath, const char *fileName);
	bool UnInitialize();

	bool GetData(char *dataToFill, unsigned int *bytesRead, bool *finished);
	
	unsigned int GetLastZLIBError();

private:

	unsigned int ErrorCode;

	HINSTANCE DllHandle;
	FILE *Stream;
	z_stream ZStream;
	unsigned int NumCompressedBytes;
	unsigned char *CompressedBuffer;

	int (__stdcall *inflateInit_) (z_stream *strm, const char *version, int stream_size);
	int (__stdcall *inflate) (z_stream *strm, int flush);
	int (__stdcall *inflateEnd) (z_stream *strm);
};
*/

#endif