#ifndef __OpenGL_h
#define __OpenGL_h

class CXGLWorld;
class CXGLObject;
class CXGLMesh;
class CXGLTexture;
class CXGLTextureBuffer;
class CXGLMaterial;
enum
{
	NormalFaces = 0,
	TextureFaces = 1,
	AlphaTextureFaces = 2,
	AlphaFaces = 3
};

void GLInit(HWND hWnd);
void GLUnInit();
void SetViewPort(int cx, int cy);
void SetGLOrtho(double left, double right, double bottom, double top, double n, double f);
void CreateWorldDisplayList(CXGLWorld *world);
unsigned int CreateMeshDisplayList(CXGLMesh *mesh, int faceType, bool forceDoubleSided);
unsigned int CreateTexture(CXGLTexture *texture);
unsigned int CreateTextureBuffer(CXGLTextureBuffer *textureBuffer);
unsigned int CreateObjectDisplayList(CXGLObject *object, int faceType);
void DeleteDisplayLists();
void RotateWorld(double fx, double fy, double fz, double ux, double uy, double uz);
void TranslateWorld(double xp, double yp, double zp);
void CallDisplayList();
void SetLinePointColor(CXGLMaterial *matArray, int *prevInd, int newInd);

#endif