#include "stdafx.h"
#include "XGLState.h"
#include "OpenGL.h"

CXGLState XGLState;

/*
This state class holds values that may be used later to calculate things for opengl and for the world.
It also calls some opengl functions in response to state changes.  TODO:  We could make the XGLViewer 
a cleaner piece of code by having all comminication to and from opengl occur through this class.  Right
now there are opengl function that our called by many classes.
*/

void
CXGLState::GetWorldPositionAndExtents(double *worldX, double *worldY, double *worldZ, double *worldExtent)
{	
	*worldX = WorldX;
	*worldY = WorldY;
	*worldZ = WorldZ;
	*worldExtent = WorldExtent;
}
	
void 
CXGLState::SetWorldPositionAndExtents(double worldX, double worldY, double worldZ, double worldExtent)
{
	WorldX = worldX;
	WorldY = worldY;
	WorldZ = worldZ;
	WorldExtent = worldExtent;
	TranslateWorld(-worldX, -worldY, -worldZ);
}

void 
CXGLState::GetWorldRotation(double *fx, double *fy, double *fz, double *ux, double *uy, double *uz)
{
	*fx = WorldFX;
	*fy = WorldFY;
	*fz = WorldFZ;
	*ux = WorldUX;
	*uy = WorldUY;
	*uz = WorldUZ;
}

void 
CXGLState::SetWorldRotation(double fx, double fy, double fz, double ux, double uy, double uz)
{
	WorldFX = fx;
	WorldFY = fy;
	WorldFZ = fz;
	WorldUX = ux;
	WorldUY = uy;
	WorldUZ = uz;

	//we should rotate the world
	RotateWorld(fx, fy, fz, ux, uy, uz);
}


void 
CXGLState::GetWindowCoords(double *x, double *y, double *z, double *xWidth, double *yWidth, double *zWidth)
{
	*x = WindowX;
	*y = WindowY;
	*z = WindowZ;
	*xWidth = WindowXWidth;
	*yWidth = WindowYWidth;
	*zWidth = WindowZWidth;
}

void 
CXGLState::SetWindowCoords(double x, double y, double z, double xWidth, double yWidth, double zWidth)
{
	WindowX = x;
	WindowY = y;
	WindowZ = z;
	WindowXWidth = xWidth;
	WindowYWidth = yWidth;
	WindowZWidth = zWidth;

	//we should resize the window
	SetGLOrtho(x - xWidth*0.5, x + xWidth*0.5, y - yWidth*0.5, y + yWidth*0.5, z - zWidth*0.5, z + zWidth*0.5);
}
